//*********************************************************
//@@PIC18F14K50  <<< HID Bootloadergp >>>
//@@GPSjbg4800bpsGGAf[^͂
//@@I2CڑLCD\ɈܓxEyx\B
//@@18rbgڂ ','ȂAȃf[^Ɣf
//     1)Define I/O PORT
//         PORTB(4)pin13    :  SDA
//         PORTB(6)pin11    :  SCL
//     2)OSC
//         4MHz 
//*********************************************************
#include <p18f14k50.h>
#include <delays.h>
#include "L_i2cLCD.h"
#include <usart.h>

#define CR_EN RCSTAbits.CREN
#define O_ERR RCSTAbits.OERR
#define Max     47
//-------------- RtBO[V ------------------------
#pragma config MCLRE  = OFF
#pragma config PWRTEN = OFF
#pragma config BOREN  = OFF
#pragma config BORV   = 30
#pragma config WDTEN  = OFF
#pragma config WDTPS  = 32768
#pragma config STVREN = ON
#pragma config FOSC   = IRC //  NbN
#pragma config PLLEN  = ON
#pragma config CPUDIV = NOCLKDIV
#pragma config USBDIV = OFF
#pragma config FCMEN  = OFF
#pragma config IESO   = OFF
#pragma config HFOFST = OFF
#pragma config LVP    = OFF
#pragma config XINST  = OFF
#pragma config BBSIZ  = OFF
#pragma config CP0    = OFF
#pragma config CP1    = OFF
#pragma config CPB    = OFF
#pragma config CPD    = OFF
#pragma config WRT0   = OFF
#pragma config WRT1   = OFF
#pragma config WRTB   = OFF
#pragma config WRTC   = OFF
#pragma config WRTD   = OFF
#pragma config EBTR0  = OFF
#pragma config EBTR1  = OFF
#pragma config EBTRB  = OFF
//

void rcvGPSword(void);
void LCD_msg(char *, char);
char str_cmp(char *, rom const char *, char);

//
#pragma code
//------------ Strings Data
char dataGPS[Max];
//f[^"GPGGA,101229.487,3723.2475,N,12158.3416,W,1,07,1.0,9.0,M, , , ,0000*3E";
//------------ Program 
void main(void){
    char i;
    OSCCON = 0b01010010;   //  NbN4Mhz
    PORTA = 0x00;
    PORTB = 0x00;
    PORTC = 0x00;
    TRISA = 0b11111111;   //PortA ׂē
    TRISB = 0b11111111;   //PortB ׂē
    TRISC = 0b11111111;   //PortC ׂē
    ANSEL  = 0b00000000;  //ׂ Degital PORT
    ANSELH = 0b00000000;
///*------------ Initialize 
    LCD_int();
    baudUSART (
        BAUD_IDLE_RX_PIN_STATE_HIGH & 
        BAUD_IDLE_TX_PIN_STATE_HIGH & 
        BAUD_16_BIT_RATE & 
        BAUD_WAKEUP_OFF & 
        BAUD_AUTO_OFF);
    OpenUSART(
        USART_TX_INT_OFF & 
        USART_RX_INT_OFF & 
        USART_ASYNCH_MODE & 
        USART_EIGHT_BIT & 
        USART_CONT_RX & 
        USART_BRGH_HIGH, 
        207);                     //4800 bps
    while (1){
        rcvGPSword();              // GPS GGAf[^̎M
        if(str_cmp(dataGPS,"GPGGA", 5)==0){
//            if(dataGPS[18]==','){  // GPSMĂȂ
            if(0){  // GPSMĂȂ
                LCD_clr();
                LCD_ROMstr("  GPS");
                LCD_posyx(1,5);
                LCD_ROMstr("No Data");
            }else{                  // GPSMĂ
                LCD_posyx(0,0);
                LCD_msg(dataGPS+6,2);  // UTC
                LCD_dat(':');
                LCD_msg(dataGPS+8,2);  // UTC
                LCD_dat(':');
                LCD_msg(dataGPS+10,2); // UTCb
                LCD_posyx(0,14);
                LCD_msg(dataGPS+44,2); // q
                LCD_posyx(1,0);
                LCD_msg(dataGPS+27,1); // N or S
                LCD_msg(dataGPS+17,6); // x
                LCD_dat(' ');
                LCD_msg(dataGPS+40,1); // W or E
                LCD_msg(dataGPS+29,7); // x
            }
        }
    } 
}
//************** GPSf[^M ***********************
//  Mf[^"$"̌ォA
//    f[^z̐܂ŁA܂
//    sė܂ŌJԂB
//*************************************************
void rcvGPSword(void){
    unsigned char i, data;
    i = 0;                          // i[|C^Zbg
    if(O_ERR)CR_EN=0,CR_EN=1;       // OverrunG[NA
    do{                             // "$"M܂ő҂
        while (!DataRdyUSART());
     }while(ReadUSART() != '$');
    do{
        while (!DataRdyUSART());    // f[^M
        data=ReadUSART();           // 
        dataGPS[i++] = data;        // f[^ۑ
        if(i >= Max) break;         // zMax܂
    }while(data != 0x0A);           // sȂI
}
//-------- o --------------------------------
// w蕶񂩂Aw蕶o͂
// ---------------------------------------------------
void LCD_msg(char *str, char num){
    while(num-- )           //w蕶p
        LCD_dat(*str++);    //o͂|C^{P
}
// ------- r --------------------------------
// w蕶ƁhhAw蕶r
// vȂuOvAsvȂ琳
// ---------------------------------------------------
char str_cmp(char *str, rom const char *msg, char num){
    do{
        if((*str++) != (*msg++))break;
    }while(--num);
    return num;
}
